
/*wb_[t@C*/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <windows.h>
#include <math.h>
#include <sys/types.h>
#include "data.h"//`͂ɈڂB
#include "fft2dc.h"//t[Gϊ̂߂̊֐ׂĒ`ĂB
#include "calculate.h"//ԔWɊ֌W֐ׂĈڂB
#include <GL/glut.h>



int main(int argc, char *argv[]);
void display(void);
void init(void);
void setrandom(void);
void mouse(int button, int state, int x, int y);
void onestep(int u);
void Steps(int steps,int delay);



int main(int argc, char *argv[]){
  srand( (unsigned)time(NULL) );
  setrandom();

  glutInitWindowPosition(IP, IP);
  glutInitWindowSize(WS, WS);
  
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);

  glutMouseFunc(mouse);

  init();

  glutMainLoop();
  return 0;
}


void display(void)
{
  double dx = (double)2/(displaysize+2);
  double color;
  int i,j;

  glClear(GL_COLOR_BUFFER_BIT);
  for(i=0;i<displaysize;++i){
	  for(j=0;j<displaysize;++j){
		  if(g_array[i+initx][j+inity] < -1){color = -1;}//if̂Ȃ-11𗼕Ƃ0ɂƐF2F݂̂ɂȂ܂B
		  else if(g_array[i+initx][j+inity] > 1){color = 1;}
		  else{color = g_array[i+initx][j+inity];}
		glBegin(GL_POLYGON);
		glColor3d((color+1)/2, 0.0, 0.0);
		glVertex2d(-1.0+dx*(i+1), -1.0+dx*(j+1));
		glVertex2d(-1.0+dx*(i+2), -1.0+dx*(j+1));
		glVertex2d(-1.0+dx*(i+2), -1.0+dx*(j+2));
		glVertex2d(-1.0+dx*(i+1), -1.0+dx*(j+2));
		glEnd();
	  }
  }

  glFlush();

}

void init(void)
{
  glClearColor(1.0, 1.0, 1.0, 1.0);
}



void setrandom(void){
	int i,j;

	for(i=0; i<g_arraysize; ++i){
		for(j=0; j<g_arraysize; ++j){
			g_array[i][j] = 1 + 0.1*(double)rand()/32767;
		}
	}
}



void mouse(int button, int state, int x, int y)
{
  switch (button) {
  case GLUT_LEFT_BUTTON:
    if (state == GLUT_DOWN) {
		Steps(500,100);
    }
    break;
  case GLUT_RIGHT_BUTTON:
    if (state == GLUT_DOWN) {
		onestep(3);		
	}
    break;
  default:
    break;
  }
}


void onestep(int u){
	//printf("%d\n",steps);
	time_evolution();
	
	glutPostRedisplay();
}
void Steps(int steps,int delay){
	int i;
	for(i=0;i<steps;++i){
		glutTimerFunc(delay*(i+1) , onestep, 0);
	}
}

